## units 2.18

=== debian/changelog ===
units (2.18-1) unstable; urgency=medium

  * New upstream release.
    - New currency sources replace the Yahoo! service which is no longer
      available. Closes: #910503.
    - Downloaded data is validated before being interpreted.
      Closes: #902935.
  * Set “Rules-Requires-Root: no”.
  * Standards-Version 4.2.1, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 22 Oct 2018 10:22:02 +0200

=== debian/control ===
Source: units
Maintainer: Stephen Kitt <skitt@debian.org>
Section: utils
Priority: optional
Build-Depends: bison,
               debhelper (>= 11~),
               libreadline-dev,
               python3,
               texinfo
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian/units
Vcs-Git: https://salsa.debian.org/debian/units.git
Homepage: https://www.gnu.org/software/units/
Rules-Requires-Root: no

Package: units
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: python3, python3-requests
Description: converts between different systems of units
 GNU 'units' program converts quantities expressed in various scales
 to their equivalents in other scales.  The 'units' program can only
 handle multiplicative scale changes directly.  It uses a functional
 notation for non-proportional conversions such a Fahrenheit
 temperature to Celsius temperature.
 .
 This package includes the units_cur script to update currency
 conversion information; this script requires a Python 3 interpreter
 and the python3-requests library.

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,pgpsigurlmangle=s/$/.sig/ \
https://ftp.gnu.org/gnu/units/ (?:.*/)?units[_\-\.]?(\d\S*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## units 2.19

=== debian/changelog ===
units (2.19-1) unstable; urgency=medium

  * Upload to unstable.
  * Standards-Version 4.4.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Thu, 15 Aug 2019 21:15:21 +0200

units (2.19-1~exp1) experimental; urgency=medium

  * New upstream release.
    - Continuation paragraphs are indented in the manpage.
      Closes: #921160.
    - The AUTHORS section of the manpage is now filled in.
      Closes: #926559.
  * Update debian/copyright.
  * Standards-Version 4.3.0, no further change required.
  * Switch to debhelper compatibility level 12.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Jun 2019 14:09:02 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Section: utils
 Priority: optional
 Build-Depends: bison,
-               debhelper (>= 11~),
+               debhelper-compat (= 12),
                libreadline-dev,
                python3,
                texinfo
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/debian/units
 Vcs-Git: https://salsa.debian.org/debian/units.git
 Homepage: https://www.gnu.org/software/units/

## units 2.21

=== debian/changelog ===
units (2.21-2) unstable; urgency=medium

  * Apply the patch provided by upstream to fix segfaults when performing
    verbose inverse lookups of table-driven units. Closes: #1003708.
  * Standards-Version 4.6.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 30 Jan 2022 21:16:37 +0100

units (2.21-1) unstable; urgency=medium

  * New upstream release.
  * Fix remaining troublesome dates in the changelog; thanks to Axel
    Beckert for pointing them out! Closes: #971974.
  * Bump debian/watch to version 4 and simplify it.
  * Update copyright information.
  * Standards-Version 4.5.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 21 Nov 2020 15:46:34 +0100

units (2.20-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit (from ./configure).
  * Fix day-of-week for changelog entry 1.55-2.
  * Update standards version to 4.4.1, no changes needed.

  [ Stephen Kitt ]
  * New upstream release.
  * Switch to debhelper compatibility level 13.
  * Standards-Version 4.5.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 10 Oct 2020 10:08:39 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Section: utils
 Priority: optional
 Build-Depends: bison,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libreadline-dev,
                python3,
                texinfo
-Standards-Version: 4.4.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/debian/units
 Vcs-Git: https://salsa.debian.org/debian/units.git
 Homepage: https://www.gnu.org/software/units/

## units 2.22

=== debian/changelog ===
units (2.22-2) unstable; urgency=medium

  * Fix the currency.units symlink. Closes: #1019337.

 -- Stephen Kitt <skitt@debian.org>  Wed, 07 Sep 2022 17:04:01 +0200

units (2.22-1) unstable; urgency=medium

  * New upstream release, merging all patches.
  * Disable the currency update check.
  * Update lintian overrides.
  * Standards-Version 4.6.1, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Tue, 06 Sep 2022 08:40:03 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libreadline-dev,
                python3,
                texinfo
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/debian/units
 Vcs-Git: https://salsa.debian.org/debian/units.git
 Homepage: https://www.gnu.org/software/units/

## units 2.23

=== debian/changelog ===
units (2.23-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:29:56 +1100

units (2.23-1build1) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 03:02:09 +0100

units (2.23-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Remove 1 maintscript entries from 1 files.

  [ Stephen Kitt ]
  * New upstream release.
  * Standards-Version 4.6.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 28 Feb 2024 11:49:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: units
-Maintainer: Stephen Kitt <skitt@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
 Section: utils
 Priority: optional
 Build-Depends: bison,
@@ -7,7 +8,7 @@
                libreadline-dev,
                python3,
                texinfo
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/units
 Vcs-Git: https://salsa.debian.org/debian/units.git
 Homepage: https://www.gnu.org/software/units/

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file - for GNU Units

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --sharedstatedir=/var/lib

override_dh_md5sums:
# There’s no point in measuring variable state
	dh_md5sums -X var/lib

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/,dversionmangle=auto,pgpsigurlmangle=s/$/.sig/ \
https://ftp.gnu.org/gnu/units/ (?:.*/)?units@ANY_VERSION@@ARCHIVE_EXT@

## units 2.24

=== Windows/Makefile ===
# Makefile for Windows binary distribution of GNU units, a program for
# units conversion
#
# Copyright (C) 2014-2024
# Free Software Foundation, Inc
#
# Last updated 2024-11-21 Jeff Conrad <jeff_conrad@msn.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#    
# This Makefile was written by Jeff Conrad (jeff_conrad@msn.com)
# and Adrian Mariano (adrianm@gnu.org) and
#
# The units program was written by Adrian Mariano
#
# Distributions through version 2.20 were compiled as 32 bit
# using MS Visual C and MS Visual Studio. # Versions since 2.21
# have been compiled as 64 bit using MS Visual Studio Community.
# The installer has been built using Inno Setup.
#
# need these files:
#  Instructions.txt -- instructions for building and uploading
#  units-xxx.iss -- installer build script template
#  Readme.txt  -- specific to Windows version
#  gnu.ico     -- for the installer to display
#  Makefile (this file) to build Windows distribution
#  lwords -- words to exclude from spelling check
#  ex.rc  -- adds special mapping for spellx and formatting paragraphs
#  UnitsForWindows.texinfo

# for PTC MKS Toolkit
.POSIX:

SHELL = /bin/sh
PROG = units
VERSION = 2.24
DISTNAME = $(PROG)-$(VERSION)
INSTALLER = $(DISTNAME)$(exename)
ZIPFILE = $(DISTNAME)$(zipname)
# for installer
exename = -setup.exe
# for zipped version of installer
zipname = -setup.zip

windir = .
# adjust this to suit
srcdir = ..

#
# specific to environment; change to suit
#
ProgFiles32 = "C:/Program Files (x86)"
ProgFiles64 = "C:/Program Files"
GPG  = $(ProgFiles32)/GnuPG/bin/gpg.exe
# Inno Setup
ISCC = $(ProgFiles32)/"Inno Setup 6"/ISCC.exe
# convert LF to CRLF: based on PTC MKS Toolkit
# assumes /bin is symlink to $ROOTDIR/mksnt
UNIX2DOS = C:/bin/flip.exe -bd
# program to remove UTF-8 marker added by MKS flip(1) and sed(1)
RMBOM = rmbom
# based on MikTeX for Windows
TEXI2PDF = $(ProgFiles64)/MiKTeX/miktex/bin/x64/texify.exe -pq
# WinZip command-line add-on; normally not needed
ZIP = $(ProgFiles64)/WinZip/WZZIP.exe

# for this Windows installer, these pathnames must include only the
# filenames
data_file = definitions.units
locale_map = locale_map.txt

INSTALLER_SCRIPT_TEMPLATE = $(windir)/$(PROG)-xxx.iss
INSTALLER_SCRIPT = $(windir)/$(PROG)-$(VERSION).iss

install_dir = $(ProgFiles64)/GNU/$(PROG)

.SUFFIXES:
.SUFFIXES: .texinfo .pdf

.texinfo.pdf:
	$(TEXI2PDF) $<

# revised for units 2.15 to reflect single version for Python 2 and Python 3
CUR_PROG = units_cur.py

# copy from source distribution
DISTFILES = $(PROG).exe $(CUR_PROG) \
            definitions.units elements.units currency.units cpi.units \
	    locale_map.txt units.pdf unitsfile.ico unitsprog.ico

# files needed for Windows builder
BUILDERFILES = Instructions.txt* Makefile.in* Readme.txt* RemoveFromPath.iss* \
               RemoveOldInstallation.iss* UnitsForWindows.texinfo* ex.rc* \
               gnu.ico* lwords* units-xxx.iss*

LICENSE = License.txt
WINTEXI = UnitsForWindows.texinfo
WINPDF = UnitsForWindows.pdf
WINFILES = Readme.txt gnu.ico

# Text files get converted from LF to CRLF if necessary
TEXTFILES = $(CUR_PROG) definitions.units elements.units currency.units cpi.units \
    locale_map.txt License.txt

FILES = $(PROG).exe $(TEXTFILES)

# targets

all: windist

windist: $(INSTALLER)

ins: $(INSTALLER)

$(INSTALLER): $(INSTALLER_SCRIPT_TEMPLATE) $(WINPDF) $(WINFILES) $(FILES)
	@if test -z $(VERSION); then \
	    echo "No version specified"; \
	    false; \
	fi
	@if ! test -d $(srcdir); then \
	    echo "Cannot find source directory '$(srcdir)'"; \
	    false; \
	fi
	# check versions of units source and executable to see if they match the specified VERSION
	# check pathnames of units data file and locale map to see if they include only the filenames
	@errors=0; \
	    echo "Checking version ..."; \
	    srcversion=`sed -n -e '/\#.*VERSION/{s/.*"\(.*\)"/\1/p;q;}' $(srcdir)/$(PROG).c`; \
	    if [ "$$srcversion" != "$(VERSION)" ]; then \
		echo "specified version ($(VERSION)) does not match source version ($$srcversion)"; \
		errors=`expr $$errors + 1`; \
	    fi; \
	    if [ ! -x $(srcdir)/$(PROG).exe ]; then \
		echo "$(srcdir)/$(PROG).exe not found; build it before creating this distribution"; \
		errors=`expr $$errors + 1`; \
	    fi; \
	    exeversion=`$(srcdir)/units -V | sed -n -e 's/^.*version[ ]*//p;q'`; \
	    if [ "$$exeversion" != "$$srcversion" ]; then \
		echo "executable version ($$exeversion) does not match source version ($$srcversion)"; \
		errors=`expr $$errors + 1`; \
	    fi; \
	    \
	    echo "Checking units data files ..."; \
	    datafile=`$(srcdir)/$(PROG) -I | sed -n -e "/Default units data file/{s/.*'\(.\{1,\}\)'.*/\1/p;q;}"`; \
	    if [ "$$datafile" != $(data_file) ]; then \
		echo "Default data file ("$$datafile") does not match '$(data_file)'"; \
		errors=`expr $$errors + 1`; \
	    fi; \
	    localemap=`$(srcdir)/$(PROG) -I | sed -n -e "/Default locale map/{s/.*'\(.\{1,\}\)'.*/\1/p;q;}"`; \
	    if [ "$$localemap" != $(locale_map) ]; then \
		echo "Default locale map ("$$localemap") does not match '$(locale_map)'"; \
		errors=`expr $$errors + 1`; \
	    fi; \
	    if [ "$$errors"  -gt 0 ]; then \
		if [ $$errors -gt 1 ]; then \
		    echo $$errors errors; \
		else \
		    echo $$errors error; \
		fi; \
		false; \
	    fi

	# generate the installer script for the specified VERSION
	@echo "Generating installer script ..."
	@sed '/define MyAppVersion/{'s/"xxx"/"$(VERSION)"/';}' $(INSTALLER_SCRIPT_TEMPLATE) \
	    > $(INSTALLER_SCRIPT)

	@echo ""
	@echo "Building $@ ..."
	@$(ISCC) $(windir)/$(INSTALLER_SCRIPT)
	@echo ""

# not used unless distribution is in WinZip format; usually needed only
# to get past an exe filter
zip: $(ZIPFILE)

$(ZIPFILE): $(INSTALLER)
	@echo "Creating $@"
	@$(ZIP) $(windir)/$(ZIPFILE) $(windir)/$(INSTALLER) > /dev/null
	@ls -l $(ZIPFILE)

$(FILES):
	@echo "Copying files:"
	@for file in $(DISTFILES); do \
	    echo "  $(srcdir)/$$file"; \
	    cp -p $(srcdir)/$$file $(windir); \
	done

	# rename file for Windows
	@echo "  $(srcdir)/COPYING to $(windir)/License.txt"
	@cp -p $(srcdir)/COPYING $(windir)/License.txt

	@make currency_update

	@echo "Converting files to CRLF:"
	@for file in $(TEXTFILES); do \
	    echo "  $$file"; \
	    $(UNIX2DOS) $$file; \
	done

# MikTeX for Windows usually needs to run twice to properly generate the
# Table of Contents
$(WINPDF): $(WINTEXI)
	@echo "Generating documentation ..."
	@$(TEXI2PDF) $(WINTEXI)
	@$(TEXI2PDF) $(WINTEXI)

currency_update:
	@if [ -x $(windir)/$(CUR_PROG) ]; then \
	    echo "Trying to update currency.units (will use existing file if this fails)"; \
	    $(windir)/$(CUR_PROG); \
	else \
	    echo "Using existing currency file"; \
	fi; \
	touch currency_update

# create binary signature and ASCII directive
winsig: windist
	@echo "Creating directive and signature"
	@echo 'version: 1.2' > $(INSTALLER).Directive
	@echo 'directory: units/windows' >> $(INSTALLER).Directive
	@echo 'filename: '$(INSTALLER) >> $(INSTALLER).Directive
	@$(GPG) --clearsign $(INSTALLER).Directive
	@$(GPG) -b $(INSTALLER)
	@ls -l $(INSTALLER).Directive.asc $(INSTALLER).sig
	@rm -f $(INSTALLER).Directive

install: windist
	$(windir)/$(INSTALLER)
	# make sure everything is OK
	$(install_dir)/$(PROG) -I

# make sure the executable is the right version, with the right paths for
# the support files
check:
	$(windir)/$(PROG) -I

# make sure the installed executable is the right version, with the right
# paths for the support files
check2:
	cd; $(install_dir)/$(PROG) -I

# see if a UTF-8 marker has been added
bomcheck:
	@file * | grep -e 'UTF-8' -e BOM

# remove any added UTF-8 markers; needs $(RMBOM) to work
rmbom:
	@$(RMBOM) $(TEXTFILES) $(CUR_PROG) *.iss *.texinfo

# get rid of the TeX auxilliary files
texclean: FORCE
	-rm -f UnitsForWindows.log \
	    *.aux *.cp *.fn *.ky *.op *.pg *.toc *.tp *.vr

clean: FORCE
	-rm -f $(INSTALLER) $(ZIPFILE) $(CUR_PROG)

distclean: clean texclean FORCE
	-rm -f $(DISTFILES) $(WINPDF) License.txt
	-rm -f $(INSTALLER_SCRIPT)
	-rm -f $(INSTALLER).directive $(INSTALLER).directive.asc $(INSTALLER).sig
	-rm -f $(ZIPFILE).directive $(ZIPFILE).directive.asc $(ZIPFILE).sig
	-rm -f currency_update

# files needed for Windows builder
# long form
listfiles: FORCE
	@ls -l $(BUILDERFILES)

# just file names
files: FORCE
	@ls $(BUILDERFILES)

list: FORCE
	@ls -l $(INSTALLER) $(DISTFILES) $(WINFILES) $(WINPDF)
	@if [ -e $(INSTALLER).Directive.asc ]; then \
	    ls -l $(INSTALLER).Directive.asc $(INSTALLER).sig; \
	fi

showsrc: FORCE
	@ls -ld $(srcdir)

# for PTC MKS make
FORCE:

# for GNU make; not recognized by PTC MKS make
.PHONY: clean texclean distclean

# Tell versions [3.59,3.63) of GNU make not to export all variables.
# Otherwise a system limit (for SysV at least) may be exceeded.
.NOEXPORT:

=== debian/changelog ===
units (2.24-2) unstable; urgency=medium

  * Force C17 to allow building with GCC 15 (which defaults to C23).
    Closes: #1098041.
  * Remove the old FSF address from debian/copyright.
  * Standards-Version 4.7.2, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 14 Sep 2025 17:30:38 +0200

units (2.24-1) unstable; urgency=medium

  * New upstream release.
  * Update to upstream’s new signing key (confirmed separately).
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 06 Dec 2024 20:45:27 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: units
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
+Maintainer: Stephen Kitt <skitt@debian.org>
 Section: utils
 Priority: optional
 Build-Depends: bison,
@@ -8,7 +7,7 @@
                libreadline-dev,
                python3,
                texinfo
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/units
 Vcs-Git: https://salsa.debian.org/debian/units.git
 Homepage: https://www.gnu.org/software/units/

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # debian/rules file - for GNU Units
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND := -std=gnu17
 
 %:
 	dh $@

## units 2.25

=== Windows/Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
 # Makefile for Windows binary distribution of GNU units, a program for
 # units conversion
 #
-# Copyright (C) 2014-2024
+# Copyright (C) 2014-2024,2026
 # Free Software Foundation, Inc
 #
-# Last updated 2024-11-21 Jeff Conrad <jeff_conrad@msn.com>
+# Last updated 2026-01-03 Jeff Conrad <jeff_conrad@msn.com>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -37,18 +37,29 @@
 #  gnu.ico     -- for the installer to display
 #  Makefile (this file) to build Windows distribution
 #  lwords -- words to exclude from spelling check
-#  ex.rc  -- adds special mapping for spellx and formatting paragraphs
+#  .exrc  -- adds special mapping for spellx and formatting paragraphs
 #  UnitsForWindows.texinfo
+#  UnitsProfile.png
+#  UnitsWinConInst.png
+#  UnitsWinTermInst.png
+#  UnitsWindow-Custom.png
+#  UnitsWindow-Default.png
 
 # for PTC MKS Toolkit
 .POSIX:
 
 SHELL = /bin/sh
-PROG = units
-VERSION = 2.24
-DISTNAME = $(PROG)-$(VERSION)
+PROGNAME = units
+PROG = $(PROGNAME).exe
+VERSION = 2.25
+DISTNAME = $(PROGNAME)-$(VERSION)
 INSTALLER = $(DISTNAME)$(exename)
 ZIPFILE = $(DISTNAME)$(zipname)
+UPLOADFILE = upload.txt
+ALPHAFILE = AlphaUpload.txt
+FTP_SITE = ftp-upload.gnu.org
+FTP = ftp -d -s:$(UPLOADFILE) $(FTP_SITE)
+AFTP = ftp -d -s:$(ALPHAFILE) $(FTP_SITE)
 # for installer
 exename = -setup.exe
 # for zipped version of installer
@@ -63,6 +74,7 @@
 #
 ProgFiles32 = "C:/Program Files (x86)"
 ProgFiles64 = "C:/Program Files"
+CMD = cmd.exe
 GPG  = $(ProgFiles32)/GnuPG/bin/gpg.exe
 # Inno Setup
 ISCC = $(ProgFiles32)/"Inno Setup 6"/ISCC.exe
@@ -81,10 +93,10 @@
 data_file = definitions.units
 locale_map = locale_map.txt
 
-INSTALLER_SCRIPT_TEMPLATE = $(windir)/$(PROG)-xxx.iss
-INSTALLER_SCRIPT = $(windir)/$(PROG)-$(VERSION).iss
-
-install_dir = $(ProgFiles64)/GNU/$(PROG)
+INSTALLER_SCRIPT_TEMPLATE = $(windir)/$(PROGNAME)-xxx.iss
+INSTALLER_SCRIPT = $(windir)/$(PROGNAME)-$(VERSION).iss
+
+install_dir = $(ProgFiles64)/GNU/$(PROGNAME)
 
 .SUFFIXES:
 .SUFFIXES: .texinfo .pdf
@@ -95,10 +107,15 @@
 # revised for units 2.15 to reflect single version for Python 2 and Python 3
 CUR_PROG = units_cur.py
 
+SOURCEFILES = units.c parse.tab.c getopt.c getopt1.c \
+              units.h getopt.h units.rc unitsprog.ico
+
+OBJS = units.obj parse.tab.obj getopt.obj getopt1.obj
+RES = units.res
+
 # copy from source distribution
-DISTFILES = $(PROG).exe $(CUR_PROG) \
-            definitions.units elements.units currency.units cpi.units \
-	    locale_map.txt units.pdf unitsfile.ico unitsprog.ico
+DISTFILES = definitions.units elements.units currency.units cpi.units \
+	    locale_map.txt units.pdf unitsfile.ico units_cur
 
 # files needed for Windows builder
 BUILDERFILES = Instructions.txt* Makefile.in* Readme.txt* RemoveFromPath.iss* \
@@ -109,12 +126,13 @@
 WINTEXI = UnitsForWindows.texinfo
 WINPDF = UnitsForWindows.pdf
 WINFILES = Readme.txt gnu.ico
+WINMAKEFILE = Makefile.Win
 
 # Text files get converted from LF to CRLF if necessary
-TEXTFILES = $(CUR_PROG) definitions.units elements.units currency.units cpi.units \
-    locale_map.txt License.txt
-
-FILES = $(PROG).exe $(TEXTFILES)
+TEXTFILES = elements.units definitions.units currency.units cpi.units \
+    locale_map.txt License.txt $(CUR_PROG)
+
+FILES = $(TEXTFILES)
 
 # targets
 
@@ -124,7 +142,7 @@
 
 ins: $(INSTALLER)
 
-$(INSTALLER): $(INSTALLER_SCRIPT_TEMPLATE) $(WINPDF) $(WINFILES) $(FILES)
+$(INSTALLER): $(INSTALLER_SCRIPT_TEMPLATE) $(FILES) $(PROG) $(WINPDF) $(WINFILES)
 	@if test -z $(VERSION); then \
 	    echo "No version specified"; \
 	    false; \
@@ -137,28 +155,19 @@
 	# check pathnames of units data file and locale map to see if they include only the filenames
 	@errors=0; \
 	    echo "Checking version ..."; \
-	    srcversion=`sed -n -e '/\#.*VERSION/{s/.*"\(.*\)"/\1/p;q;}' $(srcdir)/$(PROG).c`; \
+	    srcversion=`sed -n -e '/\#.*VERSION/{s/.*"\(.*\)"/\1/p;q;}' $(srcdir)/$(PROGNAME).c`; \
 	    if [ "$$srcversion" != "$(VERSION)" ]; then \
 		echo "specified version ($(VERSION)) does not match source version ($$srcversion)"; \
 		errors=`expr $$errors + 1`; \
 	    fi; \
-	    if [ ! -x $(srcdir)/$(PROG).exe ]; then \
-		echo "$(srcdir)/$(PROG).exe not found; build it before creating this distribution"; \
-		errors=`expr $$errors + 1`; \
-	    fi; \
-	    exeversion=`$(srcdir)/units -V | sed -n -e 's/^.*version[ ]*//p;q'`; \
+	    exeversion=`$(windir)/$(PROG) -V | sed -n -e 's/^.*version[ ]*//p;q'`; \
 	    if [ "$$exeversion" != "$$srcversion" ]; then \
 		echo "executable version ($$exeversion) does not match source version ($$srcversion)"; \
 		errors=`expr $$errors + 1`; \
 	    fi; \
 	    \
 	    echo "Checking units data files ..."; \
-	    datafile=`$(srcdir)/$(PROG) -I | sed -n -e "/Default units data file/{s/.*'\(.\{1,\}\)'.*/\1/p;q;}"`; \
-	    if [ "$$datafile" != $(data_file) ]; then \
-		echo "Default data file ("$$datafile") does not match '$(data_file)'"; \
-		errors=`expr $$errors + 1`; \
-	    fi; \
-	    localemap=`$(srcdir)/$(PROG) -I | sed -n -e "/Default locale map/{s/.*'\(.\{1,\}\)'.*/\1/p;q;}"`; \
+	    localemap=`$(windir)/$(PROGNAME) -I | sed -n -e "/Default locale map/{s/.*'\(.\{1,\}\)'.*/\1/p;q;}"`; \
 	    if [ "$$localemap" != $(locale_map) ]; then \
 		echo "Default locale map ("$$localemap") does not match '$(locale_map)'"; \
 		errors=`expr $$errors + 1`; \
@@ -182,15 +191,6 @@
 	@$(ISCC) $(windir)/$(INSTALLER_SCRIPT)
 	@echo ""
 
-# not used unless distribution is in WinZip format; usually needed only
-# to get past an exe filter
-zip: $(ZIPFILE)
-
-$(ZIPFILE): $(INSTALLER)
-	@echo "Creating $@"
-	@$(ZIP) $(windir)/$(ZIPFILE) $(windir)/$(INSTALLER) > /dev/null
-	@ls -l $(ZIPFILE)
-
 $(FILES):
 	@echo "Copying files:"
 	@for file in $(DISTFILES); do \
@@ -201,6 +201,14 @@
 	# rename file for Windows
 	@echo "  $(srcdir)/COPYING to $(windir)/License.txt"
 	@cp -p $(srcdir)/COPYING $(windir)/License.txt
+	@echo "  $(srcdir)/units_cur to $(windir)/$(CUR_PROG)"
+	@cp -p $(srcdir)/units_cur $(windir)/$(CUR_PROG)
+	@echo "Checking for UTF-8 markers ..."
+	@result=`file * | grep -e 'UTF-8' -e BOM`; \
+	if [ -n "$$result" ]; then \
+	  echo "$$result"; \
+	  false; \
+	fi
 
 	@make currency_update
 
@@ -209,6 +217,32 @@
 	    echo "  $$file"; \
 	    $(UNIX2DOS) $$file; \
 	done
+
+$(PROG):
+	@echo "Copying source files:"
+	@for file in $(SOURCEFILES) $(WINMAKEFILE); do \
+	    echo "  $(srcdir)/$$file"; \
+	    cp -p $(srcdir)/$$file $(windir); \
+	done
+
+	@echo "Checking for UTF-8 markers ..."
+	@result=`file * | grep -e 'UTF-8' -e BOM`; \
+	if [ -n "$$result" ]; then \
+	  echo "$$result"; \
+	  false; \
+	fi
+
+	@echo "Building $(PROGNAME) for Windows ..."
+	@$(CMD) /c "nmake -f $(WINMAKEFILE)"
+
+# not used unless distribution is in WinZip format; usually needed only
+# to get past an exe filter
+zip: $(ZIPFILE)
+
+$(ZIPFILE): $(INSTALLER)
+	@echo "Creating $@"
+	@$(ZIP) $(windir)/$(ZIPFILE) $(windir)/$(INSTALLER) > /dev/null
+	@ls -l $(ZIPFILE)
 
 # MikTeX for Windows usually needs to run twice to properly generate the
 # Table of Contents
@@ -226,39 +260,62 @@
 	fi; \
 	touch currency_update
 
+install: windist
+	$(windir)/$(INSTALLER)
+	# make sure everything is OK
+	cd; $(install_dir)/$(PROGNAME) -I
+
+# make sure the executable is the right version, with the right paths for
+# the support files
+check:
+	$(windir)/$(PROGNAME) -I
+
+# make sure the installed executable is the right version, with the right
+# paths for the support files
+check2:
+	cd; $(install_dir)/$(PROGNAME) -I
+
+# see if a UTF-8 marker has been added
+bomcheck:
+	@result=`file * | grep -e 'UTF-8' -e BOM`; \
+	  if [ -n "$$result" ]; then \
+	    echo "$$result"; \
+	  fi;
+
+# remove any added UTF-8 markers; needs $(RMBOM) to work
+rmbom:
+	@$(RMBOM) $(TEXTFILES) $(CUR_PROG) *.iss *.texinfo
+
 # create binary signature and ASCII directive
 winsig: windist
 	@echo "Creating directive and signature"
-	@echo 'version: 1.2' > $(INSTALLER).Directive
-	@echo 'directory: units/windows' >> $(INSTALLER).Directive
-	@echo 'filename: '$(INSTALLER) >> $(INSTALLER).Directive
-	@$(GPG) --clearsign $(INSTALLER).Directive
+	@echo 'version: 1.2' >> $(INSTALLER).directive
+	@echo 'directory: units/windows' >> $(INSTALLER).directive
+	@echo 'filename: '$(INSTALLER) >> $(INSTALLER).directive
+	@$(GPG) --clearsign $(INSTALLER).directive
 	@$(GPG) -b $(INSTALLER)
-	@ls -l $(INSTALLER).Directive.asc $(INSTALLER).sig
-	@rm -f $(INSTALLER).Directive
-
-install: windist
-	$(windir)/$(INSTALLER)
-	# make sure everything is OK
-	$(install_dir)/$(PROG) -I
-
-# make sure the executable is the right version, with the right paths for
-# the support files
-check:
-	$(windir)/$(PROG) -I
-
-# make sure the installed executable is the right version, with the right
-# paths for the support files
-check2:
-	cd; $(install_dir)/$(PROG) -I
-
-# see if a UTF-8 marker has been added
-bomcheck:
-	@file * | grep -e 'UTF-8' -e BOM
-
-# remove any added UTF-8 markers; needs $(RMBOM) to work
-rmbom:
-	@$(RMBOM) $(TEXTFILES) $(CUR_PROG) *.iss *.texinfo
+	@ls -l $(INSTALLER).directive.asc $(INSTALLER).sig
+	@rm -f $(INSTALLER).directive
+
+upload: $(INSTALLER).directive.asc
+	@date
+	@echo 'anonymous' > $(UPLOADFILE)
+	@echo 'cd /incoming/ftp/' >> $(UPLOADFILE)
+	@echo 'put $(INSTALLER)' >> $(UPLOADFILE)
+	@echo 'put $(INSTALLER).directive.asc' >> $(UPLOADFILE)
+	@echo 'put $(INSTALLER).sig' >> $(UPLOADFILE)
+	@echo 'quit' >> $(UPLOADFILE)
+	$(FTP)
+
+alpha: $(INSTALLER).directive.asc
+	@date
+	@echo 'anonymous' > $(ALPHAFILE)
+	@echo 'cd /incoming/alpha/' >> $(ALPHAFILE)
+	@echo 'put $(INSTALLER)' >> $(ALPHAFILE)
+	@echo 'put $(INSTALLER).directive.asc' >> $(ALPHAFILE)
+	@echo 'put $(INSTALLER).sig' >> $(ALPHAFILE)
+	@echo 'quit' >> $(ALPHAFILE)
+	$(AFTP)
 
 # get rid of the TeX auxilliary files
 texclean: FORCE
@@ -266,7 +323,9 @@
 	    *.aux *.cp *.fn *.ky *.op *.pg *.toc *.tp *.vr
 
 clean: FORCE
-	-rm -f $(INSTALLER) $(ZIPFILE) $(CUR_PROG)
+	-rm -f $(INSTALLER) $(ZIPFILE) $(PROG) $(OBJS) $(RES) $(CUR_PROG)
+	-rm -f $(SOURCEFILES) $(WINMAKEFILE)
+	-rm -f $(UPLOADFILE) $(ALPHAFILE)
 
 distclean: clean texclean FORCE
 	-rm -f $(DISTFILES) $(WINPDF) License.txt
@@ -284,10 +343,19 @@
 files: FORCE
 	@ls $(BUILDERFILES)
 
+# files included in upload
+# long form
+llist: FORCE
+	@ls -l $(INSTALLER) $(DISTFILES) $(WINFILES) $(WINPDF)
+	@if [ -e $(INSTALLER).directive.asc ]; then \
+	    ls -l $(INSTALLER).directive.asc $(INSTALLER).sig; \
+	fi
+
+# just names
 list: FORCE
-	@ls -l $(INSTALLER) $(DISTFILES) $(WINFILES) $(WINPDF)
-	@if [ -e $(INSTALLER).Directive.asc ]; then \
-	    ls -l $(INSTALLER).Directive.asc $(INSTALLER).sig; \
+	@ls $(INSTALLER) $(DISTFILES) $(WINFILES) $(WINPDF)
+	@if [ -e $(INSTALLER).directive.asc ]; then \
+	    ls $(INSTALLER).directive.asc $(INSTALLER).sig; \
 	fi
 
 showsrc: FORCE

=== debian/changelog ===
units (2.25-1) unstable; urgency=medium

  * New upstream release.
  * Drop “Rules-Requires-Root: no” since it’s now the default.
  * Drop “Priority: optional” since it’s now the default.
  * Standards-Version 4.7.3, no further change required.
  * Update debian/watch to version 5.

 -- Stephen Kitt <skitt@debian.org>  Sat, 31 Jan 2026 12:31:07 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: units
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: utils
-Priority: optional
 Build-Depends: bison,
                debhelper-compat (= 13),
                libreadline-dev,
                python3,
                texinfo
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/units
 Vcs-Git: https://salsa.debian.org/debian/units.git
 Homepage: https://www.gnu.org/software/units/
-Rules-Requires-Root: no
 
 Package: units
 Architecture: any

=== debian/watch ===
Version: 5

Source: https://ftp.gnu.org/gnu/units/
Matching-Pattern: (?:.*/)?units@ANY_VERSION@@ARCHIVE_EXT@
Dversionmangle: auto
Pgpsigurlmangle: s/$/.sig/
Uversionmangle: s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/

## units 2.26

=== Windows/Makefile ===
--- 
+++ 
@@ -51,7 +51,7 @@
 SHELL = /bin/sh
 PROGNAME = units
 PROG = $(PROGNAME).exe
-VERSION = 2.25
+VERSION = 2.26
 DISTNAME = $(PROGNAME)-$(VERSION)
 INSTALLER = $(DISTNAME)$(exename)
 ZIPFILE = $(DISTNAME)$(zipname)

=== debian/changelog ===
units (2.26-1) unstable; urgency=medium

  * New upstream release, obsoleting packetizer.patch.
  * Update Lintian overrides to handle the split update files.
  * Update the units_cur man page.

 -- Stephen Kitt <skitt@debian.org>  Sat, 28 Feb 2026 23:21:30 +0100

units (2.25-2) unstable; urgency=medium

  * Switch to new packetizer.com URLs in units_cur. Closes: #1128412.

 -- Stephen Kitt <skitt@debian.org>  Thu, 19 Feb 2026 18:30:49 +0100
